// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ACCELGROUP_H
#define _GTKMM_ACCELGROUP_H

#include <glibmm.h>

/* $Id: accelgroup.hg,v 1.22 2002/04/16 13:01:52 murrayc Exp $ */

/* accelgroup.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <gtkmm/object.h>
#include <gdkmm/window.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkAccelGroup GtkAccelGroup;
typedef struct _GtkAccelGroupClass GtkAccelGroupClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class AccelGroup_Class; } // namespace Gtk
namespace Gtk
{

/* You can use Gtk::Window::get_accel_group() to get an accel group for that window,
 * then use it with other widgets too.
 */

class AccelGroup : public Glib::Object
{
   public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef AccelGroup          CppObjectType;
  typedef AccelGroup_Class    CppClassType;
  typedef GtkAccelGroup           BaseObjectType;
  typedef GtkAccelGroupClass      BaseClassType;

private:
  friend class AccelGroup_Class;
  static CppClassType accelgroup_class_;

  AccelGroup(const AccelGroup&);
  AccelGroup& operator=(const AccelGroup&); // not implemented

protected:
  explicit AccelGroup(GtkAccelGroup* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~AccelGroup();

  static Glib::RefPtr<AccelGroup> wrap_specific_type(GtkAccelGroup* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkAccelGroup* gobj()             { return (GtkAccelGroup*)(gobject_); }
  const GtkAccelGroup* gobj() const { return (GtkAccelGroup*)(gobject_); }

  GtkAccelGroup* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_accel_changed(guint keyval, GdkModifierType modifier, GClosure* accel_closure);


private:

   
protected:

  AccelGroup();

public:
  
  static Glib::RefPtr<AccelGroup> create();


//  static Glib::RefPtr<AccelGroup> get_default();

  
  void lock();
  
  void	unlock();
  
  bool disconnect_key(guint accel_key, Gdk::ModifierType accel_mods);

  //: activates an accelerator in all groups belonging to an object
  //static bool activate(const Glib::RefPtr<Glib::Object>& obj, guint accel_key, Gdk::ModifierType accel_mods);

  // Accelerator functions
  //
  static bool valid(guint keyval, Gdk::ModifierType modifiers);
  static void parse(const Glib::ustring & accelerator,
		    guint& accelerator_key, // out arg
		    Gdk::ModifierType& accelerator_mods); // out arg

  static Glib::ustring name(guint accelerator_key,
		     Gdk::ModifierType accelerator_mods);

  static void  set_default_mod_mask(Gdk::ModifierType default_mod_mask);
  static Gdk::ModifierType get_default_mod_mask();


  //Internal functions:
  //TODO: Comment them out to see whether they are used.

  //: activates an accelerator in this group
  bool activate(guint accel_key, Gdk::ModifierType accel_mod);

//  _WRAP_METHOD(void	attach(const Glib::RefPtr<Glib::Object>& object), gtk_accel_group_attach)
//  _WRAP_METHOD(void detach(const Glib::RefPtr<Glib::Object>& object), gtk_accel_group_detach)

//TODO: Wrap these?
//void		gtk_accel_group_handle_add	(GObject	*object,
//						 guint		 accel_signal_id,
//						 GtkAccelGroup	*accel_group,
//						 guint		 accel_key,
//						 Gdk::ModifierType accel_mods,
//						 AccelFlags   accel_flags);
//void		gtk_accel_group_handle_remove	(GObject	*object,
//						 GtkAccelGroup	*accel_group,
//						 guint		 accel_key,
//						 Gdk::ModifierType accel_mods);
//guint		gtk_accel_group_create_add	(GType		 class_type,
//						 GSignalFlags    signal_flags,
//						 guint		 handler_offset);
//guint		gtk_accel_group_create_remove	(GType		 class_type,
//						 GSignalFlags    signal_flags,
//						 guint		 handler_offset);


//GSList*	gtk_accel_groups_from_object (GObject	*object);
//GSList*	gtk_accel_group_entries_from_object	(GObject	*object);

  
  /**
   * @par Prototype:
   * <tt>void %accel_changed(guint keyval, GdkModifierType modifier, GClosure* accel_closure)</tt>
   */
  Glib::SignalProxy3<void,guint,GdkModifierType,GClosure*> signal_accel_changed();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::AccelGroup */
  Glib::RefPtr<Gtk::AccelGroup> wrap(GtkAccelGroup* object, bool take_copy = false);
}


#endif /* _GTKMM_ACCELGROUP_H */

