// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_MENU_H
#define _GTKMM_MENU_H

#include <glibmm.h>

/* $Id: menu.hg,v 1.26 2002/04/01 16:19:34 murrayc Exp $ */

/* menu.h
 * 
 * Copyright (C) 1998-2000 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <gtk/gtkmenu.h>
#include <gtkmm/menushell.h>
#include <gtkmm/menuitem.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkMenu GtkMenu;
typedef struct _GtkMenuClass GtkMenuClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Menu_Class; } // namespace Gtk
namespace Gtk
{

class AccelGroup;

/** @ingroup Widgets
 */

class Menu : public MenuShell
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Menu CppObjectType;
  typedef Menu_Class CppClassType;
  typedef GtkMenu BaseObjectType;
  typedef GtkMenuClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Menu();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class Menu_Class;
  static CppClassType menu_class_;

  Menu(const Menu&);
  Menu& operator=(const Menu&); // not implemented

protected:
  explicit Menu(GtkMenu* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkMenu* gobj()             { return (GtkMenu*)(gobject_); }
  const GtkMenu* gobj() const { return (GtkMenu*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

  
public:
  Menu();
  

/* append, prepend, and insert are defined in MenuShell */

/* Note: GtkMenuPositionFunc is not very good for us */

  //: Display the menu on screen
  // When there is a parent menu 
  
  void popup(MenuShell& parent_menu_shell, MenuItem& parent_menu_item, GtkMenuPositionFunc func, gpointer data, guint button, guint32 activate_time);

//: Display the menu on screen
  // When there is not a parent menu
  void popup(GtkMenuPositionFunc func, gpointer data, guint button, guint32 activate_time);

  /// popup a floating menu
  void popup(guint button, guint32 activate_time);

  //- Position the menu according to it's position function. This wraps
  //- a function called by gtkmenuitem.c when a menu-item changes
  //- its allocation. You most likely don't need to care about it.
  
  void reposition();

  //: Hides the menu
  
  void popdown();

  //- Keep track of the last menu item selected, for the purposes
  //- of the option menu
  
  MenuItem* get_active();
  
  void set_active(guint index);

  // The accel group may or may not be there
  
  void set_accel_group(const Glib::RefPtr<AccelGroup>& accel_group);
  void unset_accel_group();
  
  Glib::RefPtr<AccelGroup> get_accel_group();

  
  void set_accel_path(const Glib::ustring& accel_path);

  //- Detach the menu from the widget it was attached to
  //- (calls the passed {\var detacher} function)
  
  void detach();
  
  Widget* get_attach_widget();

  
  void set_tearoff_state(bool torn_off = true);
  
  bool get_tearoff_state() const;

  //- Sets the window manager title for the window that
  //- appears when a menu is torn off
  
  void set_title(const Glib::ustring& title);
  void remove_title();
  
  Glib::ustring get_title() const;

  void reorder_child(const MenuItem& child, int position);

  Glib::PropertyProxy<Glib::ustring> property_tearoff_title();


protected:
  //- Attach the menu to a widget. {\var detacher} is a function which takes
  //- the attached GtkWidget* and GtkMenu*
  //- ({\b NOTE! NOT the Gtk::Widget and Gtk::Menu!})
  //- This is mostly used by other widgets like Gtk::MenuItem or
  //- Gtk::NoteBook. You probably don't need to care about it.
  
  void attach_to_widget(Widget& widget, GtkMenuDetachFunc detacher);


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Menu */
  Gtk::Menu* wrap(GtkMenu* object, bool take_copy = false);
}
#endif /* _GTKMM_MENU_H */

