// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_NOTEBOOK_H
#define _GTKMM_NOTEBOOK_H

#include <glibmm.h>

/* $Id: notebook.hg,v 1.36 2002/04/09 17:08:13 daniel Exp $ */

/* notebook.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/container.h>
#include <gtkmm/label.h>
#include <gtk/gtknotebook.h> //Needed for GtkNotebookPage
#include <glibmm/helperlist.h>


//TODO:
//Copied from .c file. Not good. murrayc
struct _GtkNotebookPage
{
  GtkWidget *child;
  GtkWidget *tab_label;
  GtkWidget *menu_label;

  guint default_menu : 1;       /* If true, we create the menu label ourself */
  guint default_tab  : 1;       /* If true, we create the tab label ourself */
  guint expand       : 1;
  guint fill         : 1;
  guint pack         : 1;

  GtkRequisition requisition;
  GtkAllocation allocation;

  guint mnemonic_activate_signal;
};

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkNotebook GtkNotebook;
typedef struct _GtkNotebookClass GtkNotebookClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Notebook_Class; } // namespace Gtk
namespace Gtk
{


/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum NotebookTab
{
  NOTEBOOK_TAB_FIRST,
  NOTEBOOK_TAB_LAST
};

} // namespace Gtk

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::NotebookTab> : public Glib::Value_Enum<Gtk::NotebookTab>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


class Notebook;

namespace Notebook_Helpers
{
/*********************************************************************
***** Page Properties
*********************************************************************/

// we will have to muck a good bit to get this to work.
// output type
class Page : protected GtkNotebookPage
{
private:
  Page& operator=(const Page&);
  Page(const Page&);
protected:
  Page(void* do_not_derive_this);

public:
  GtkNotebookPage* gobj() {return (this);}

  Widget* get_child();
  Widget* get_tab();
  Widget* get_menu();
  Glib::ustring get_tab_text();

  void set_tab (Widget* tab=0);
  void set_tab (Widget& tab);
  void set_tab_text(const Glib::ustring& str);
  void remove_tab_text();
  void set_menu(Widget* menu=0);
  void set_menu(Widget& menu);

  bool get_expand();
  bool get_fill();
  PackType get_pack();
  void set_tab_packing(bool expand,bool fill,PackType pack_type);

protected:
  // This is the key to wrapping this type
  GtkNotebook* parent()
    {return GTK_NOTEBOOK(gobj()->child->parent);}
};

// input type (Factory)
class PageList;

class Element
{
public:
  Element(Widget* child, Widget* tab, Widget* menu)
      : child_(child), tab_(tab), menu_(menu)
    {}
  Element(Widget& child, Widget& tab, Widget& menu)
      : child_(&child), tab_(&tab), menu_(&menu)
    {}
  Element(Widget& child)
      : child_(&child), tab_(0), menu_(0)
    {}

protected:
  friend class PageList;
  Widget   *child_;
  Widget   *tab_;
  Widget   *menu_;
};

// Just a widget without a tab
typedef Element WidgetElem;

struct TabElem : public Element
{
  TabElem(Widget& child,Widget& tab)
      : Element(&child,&tab,0)
    {}
  TabElem(Widget& child, const Glib::ustring& label, bool mnemonic = false)
      : Element(&child,manage( new Label(label, mnemonic)),0)
    {}
 };

struct MenuElem : public Element
{
  MenuElem(Widget& child,Widget& menu)
      : Element(&child,0,&menu)
    {}
};

/*********************************************************************
***** List properties
*********************************************************************/
 
  // This still needs some work.
  
  
class PageList : public Glib::HelperList< Page*, const Element, Glib::List_Iterator< Page* > >
{
public:
  PageList();
  explicit PageList(GtkNotebook* gparent);
  PageList(const PageList& src);
  virtual ~PageList() {}

  PageList& operator=(const PageList& src);

  typedef Glib::HelperList< Page*, const Element,  Glib::List_Iterator< Page* > > type_base;

  GtkNotebook* gparent();
  const GtkNotebook* gparent() const;

  virtual GList*& glist() const;      // front of list

  virtual void erase(iterator start, iterator stop);
  virtual iterator erase(iterator);  //Implented as custom or by LIST_CONTAINER_REMOVE
  virtual void remove(const_reference); //Implented as custom or by LIST_CONTAINER_REMOVE

  value_type front() const     { return *begin(); }
  value_type back() const      { return *(--end()); }

  /// This is order n. (use at own risk)
  value_type operator[](size_type l) const;

public:
  iterator insert(iterator position, element_type& e); //custom-implemented.

  template <class InputIterator>
  inline void insert(iterator position, InputIterator first, InputIterator last)
  {
    for(;first != last; ++first)
      position = insert(position, *first);
  }

 inline void push_front(element_type& e)
    { insert(begin(), e); }
  inline void push_back(element_type& e)
    { insert(end(), e); }


virtual void remove(Widget& w); //Implented as custom or by LIST_CONTAINER_REMOVE

        // Non-standard
  void reorder(iterator loc, iterator page);
  
  iterator find(const_reference c);
  iterator find(Widget&);

  };


} /* Notebook_Helpers */

/** container which shows one of its children at a time, in tabbed windows.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class Notebook : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Notebook CppObjectType;
  typedef Notebook_Class CppClassType;
  typedef GtkNotebook BaseObjectType;
  typedef GtkNotebookClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Notebook();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class Notebook_Class;
  static CppClassType notebook_class_;

  Notebook(const Notebook&);
  Notebook& operator=(const Notebook&); // not implemented

protected:
  explicit Notebook(GtkNotebook* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkNotebook* gobj()             { return (GtkNotebook*)(gobject_); }
  const GtkNotebook* gobj() const { return (GtkNotebook*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_switch_page(GtkNotebookPage* page, guint page_num);
  virtual bool on_select_page(bool move_focus);
  virtual bool on_focus_tab(NotebookTab type);
  virtual void on_change_current_page(int offset);
  virtual void on_move_focus_out(DirectionType direction);


private:

public:

  typedef Notebook_Helpers::Page     Page;
  typedef Notebook_Helpers::Element  Element;
  typedef Notebook_Helpers::PageList PageList;

  Notebook();
  

//  _WRAP_METHOD(,)

/* Page controls */
  
  int get_current_page_num();
  
  Widget* get_nth_page(int page_number);
  
  int page_num(const Widget &child);
  
  void set_current_page(int page_number);
  
  void next_page();
  
  void prev_page();

  Page* get_current() const;
  // deprecated (use notebook.get_current().child()
  Widget* get_current_child();


/* Style */
  PositionType get_tab_pos() const;
  bool get_show_tabs() const;
  bool get_show_border() const;

  
  void set_show_border(bool show_border);
  
  void set_show_tabs(bool show_tabs);

  //: pos is one of GTK_POS_LEFT, GTK_POS_RIGHT, GTK_POS_TOP, GTK_POS_BOTTOM
  
  void set_tab_pos(PositionType pos);

  // deprecated:
  //_WRAP_METHOD(void set_homogeneous_tabs(bool homogeneous),gtk_notebook_set_homogeneous_tabs)
  //_WRAP_METHOD(void set_tab_border(guint border_width),gtk_notebook_set_tab_border)
  //_WRAP_METHOD(void set_tab_hborder(guint tab_hborder),gtk_notebook_set_tab_hborder)
  //_WRAP_METHOD(void set_tab_vborder(guint tab_vborder),gtk_notebook_set_tab_vborder)

  
  void set_scrollable(bool scrollable);


/* Popup */
  
  void popup_enable();

  
  void popup_disable();

// FIXME
//#m4begin
//GTKMM_SECTION(SECTION_USR)
//          void operator ()(Notebook_Helpers::Page* p) {emit(p,(guint)-1);}
//          void emit(Notebook_Helpers::Page* p) {emit(p,(guint)-1);}
//#m4end
  //fake
// FIXME: switch_page is lame.  Needs a pagenumber and a page!
//  __WRAP(sig|impl,
//        void switch_page(Notebook_Helpers::Page*,guint),
//        void gtkmm_notebook_switch_page(GtkNotebook*,GtkNotebookPage*,guint),
//        "switch_page")

  //: (deprecated)
  //_WRAP_METHOD(void prepend_page(Widget&, Widget&),gtk_notebook_prepend_page)

  //: (deprecated)
  //_WRAP_METHOD(void append_page(Widget&, Widget&),gtk_notebook_append_page)

  PageList& pages();
  const PageList& pages() const;

  
  /**
   * @par Prototype:
   * <tt>void %switch_page(GtkNotebookPage* page, guint page_num)</tt>
   */
  Glib::SignalProxy2<void,GtkNotebookPage*,guint> signal_switch_page();


  /**
   * @par Prototype:
   * <tt>bool %select_page(bool move_focus)</tt>
   */
  Glib::SignalProxy1<bool,bool> signal_select_page();

  
  /**
   * @par Prototype:
   * <tt>bool %focus_tab(NotebookTab type)</tt>
   */
  Glib::SignalProxy1<bool,NotebookTab> signal_focus_tab();

  
  /**
   * @par Prototype:
   * <tt>void %change_current_page(int offset)</tt>
   */
  Glib::SignalProxy1<void,int> signal_change_current_page();

  
  /**
   * @par Prototype:
   * <tt>void %move_focus_out(DirectionType direction)</tt>
   */
  Glib::SignalProxy1<void,DirectionType> signal_move_focus_out();


protected:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  mutable PageList pages_proxy_;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Notebook */
  Gtk::Notebook* wrap(GtkNotebook* object, bool take_copy = false);
}
#endif /* _GTKMM_NOTEBOOK_H */

