// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_TREEVIEW_H
#define _GTKMM_TREEVIEW_H

#include <glibmm.h>

/* $Id: treeview.hg,v 1.37 2002/04/17 13:46:57 murrayc Exp $ */


/* treeview.h
 *
 * Copyright(C) 2001 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/listhandle.h>
#include <gtkmm/container.h>
#include <gtkmm/adjustment.h>
#include <gdkmm/pixmap.h>
#include <gtkmm/treeviewcolumn.h>
#include <gtkmm/treeselection.h>
//#include <gtkmm/treemodel.h>
#include <gtkmm/cellrenderer.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkTreeView GtkTreeView;
typedef struct _GtkTreeViewClass GtkTreeViewClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class TreeView_Class; } // namespace Gtk
namespace Gtk
{


/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum TreeViewDropPosition
{
  TREE_VIEW_DROP_BEFORE,
  TREE_VIEW_DROP_AFTER,
  TREE_VIEW_DROP_INTO_OR_BEFORE,
  TREE_VIEW_DROP_INTO_OR_AFTER
};

} // namespace Gtk

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::TreeViewDropPosition> : public Glib::Value_Enum<Gtk::TreeViewDropPosition>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


//class TreeViewColumn;
class TreeModel;

/** @defgroup TreeView TreeView Classes
 * These classes are used with the Gtk::TreeView widget.
 */

/**
 * @ingroup Widgets
 * @ingroup Containers
 * @ingroup TreeView
 */

class TreeView : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TreeView CppObjectType;
  typedef TreeView_Class CppClassType;
  typedef GtkTreeView BaseObjectType;
  typedef GtkTreeViewClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~TreeView();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class TreeView_Class;
  static CppClassType treeview_class_;

  TreeView(const TreeView&);
  TreeView& operator=(const TreeView&); // not implemented

protected:
  explicit TreeView(GtkTreeView* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkTreeView* gobj()             { return (GtkTreeView*)(gobject_); }
  const GtkTreeView* gobj() const { return (GtkTreeView*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_set_scroll_adjustments(Adjustment* hadjustment, Adjustment* vadjustment);
  virtual void on_row_activated(const TreePath& path, TreeViewColumn* column);
  virtual bool on_test_expand_row(const TreeIter& iter, const TreePath& path);
  virtual bool on_test_collapse_row(const TreeIter& iter, const TreePath& path);
  virtual void on_row_expanded(const TreeIter& iter, const TreePath& path);
  virtual void on_row_collapsed(const TreeIter& iter, const TreePath& path);
  virtual void on_cursor_changed();
  virtual void on_columns_changed();
  virtual bool on_move_cursor(MovementStep step, int count);
  virtual void on_select_all();
  virtual void on_unselect_all();
  virtual void on_select_cursor_row(bool start_editing);
  virtual void on_toggle_cursor_row();
  virtual void on_expand_collapse_cursor_row(bool logical, bool expand, bool open_all);
  virtual void on_select_cursor_parent();
  virtual void on_start_interactive_search();


private:

  
public:

  TreeView();
  explicit TreeView(const Glib::RefPtr<TreeModel>& model);
  

  Glib::RefPtr<TreeModel> get_model();
  
  void set_model(const Glib::RefPtr<TreeModel>& model);
  
  Glib::RefPtr<TreeSelection> get_selection();
  
  Adjustment* get_hadjustment();
  
  void set_hadjustment(Adjustment& adjustment);
  
  Adjustment* get_vadjustment();
  
  void set_vadjustment(Adjustment& adjustment);
  
  bool get_headers_visible();
  
  void set_headers_visible(bool headers_visible);
  
  void columns_autosize();
  
  void set_headers_clickable(bool setting = true);
  
  void set_rules_hint(bool setting = true);
  
  bool get_rules_hint();

  
  int append_column(TreeViewColumn& column);
  
  int remove_column(TreeViewColumn& column);
  
  int insert_column(TreeViewColumn& column, int position);
  int insert_column(int position, const Glib::ustring& title, CellRenderer& cell);
  //_WRAP_METHOD(int insert_column_with_attributes(int position, const Glib::ustring& title, GtkCellRenderer* cell, ...), )


  typedef TreeViewColumn::SlotCellData SlotCellData;
  int insert_column_with_data_func(int position, const Glib::ustring& title, CellRenderer& cell, const SlotCellData& slot);

  
  TreeViewColumn* get_column(int n);
  
  Glib::ListHandle<TreeViewColumn*> get_columns();
  
  void move_column_after(TreeViewColumn& column, TreeViewColumn& base_column);
  
  void set_expander_column(TreeViewColumn& column);
  
  TreeViewColumn* get_expander_column();

  //bool on_column_drop(TreeView*, tree_view, TreeViewColumn* column, TreeViewColumn* prev_column,TreeViewColumn* next_column)
  typedef SigC::Slot4<bool, TreeView*, TreeViewColumn*,  TreeViewColumn*, TreeViewColumn*> SlotColumnDrop;
  void set_column_drag_function(const SlotColumnDrop& slot);
  

  void scroll_to_point(int tree_x, int tree_y);
  
  void scroll_to_cell(const TreePath& path, TreeViewColumn& column, bool use_align, float row_align, float col_align);
  
  void row_activated(const TreePath& path,TreeViewColumn& column);
  
  void expand_all();
  
  void collapse_all();
  
  bool expand_row(const TreePath& path, bool open_all);
  
  bool collapse_row(const TreePath& path);

  //void on_map_expanded_rows(TreeView* tree_view, const TreePath& path);
  typedef SigC::Slot2<void, TreeView*, const TreePath&> SlotMapping;
  void map_expanded_rows(const SlotMapping slot);
  

  bool row_expanded(const TreePath& path);
  
  void set_reorderable(bool reorderable = true);
  
  bool get_reorderable();
  
  void set_cursor(const TreePath& path, TreeViewColumn& focus_column, bool start_editing);
  void get_cursor(TreePath& path, TreeViewColumn*& focus_column);

/* Layout information */
  
  Glib::RefPtr<Gdk::Window> get_bin_window();
  bool get_path_at_pos(int x, int y, TreePath& path, TreeViewColumn*& column, int& cell_x, int& cell_y);
  
  void get_cell_area(const TreePath& path, TreeViewColumn& column, Gdk::Rectangle&  rect);
  
  void get_background_area(const TreePath& path, TreeViewColumn& column, Gdk::Rectangle&  rect);
  
  void get_visible_rect(Gdk::Rectangle&  visible_rect);
  
  void widget_to_tree_coords(int wx, int wy, int& tx, int& ty);
  
  void tree_to_widget_coords(int tx, int ty, int& wx, int& wy);

/* Drag-and-Drop support */
  
  void enable_model_drag_source(Gdk::ModifierType start_button_mask, const GtkTargetEntry* targets, int n_targets,
                         Gdk::DragAction actions);
  
  void enable_model_drag_dest(const GtkTargetEntry* targets, int n_targets, Gdk::DragAction actions);
  
  void unset_rows_drag_source();
  
  void unset_rows_drag_dest();


/* These are useful to implement your own custom stuff. */
  
  void set_drag_dest_row(const TreePath& path, TreeViewDropPosition pos);
  void get_drag_dest_row(TreePath& path, TreeViewDropPosition& pos);
  bool get_dest_row_at_pos(int drag_x, int drag_y, TreePath& path, TreeViewDropPosition& pos);
  
  Glib::RefPtr<Gdk::Pixmap> create_row_drag_icon(const TreePath& path);

/* Interactive search */
  
  void set_enable_search(bool enable_search = true);
  
  bool get_enable_search();
  
  int get_search_column();
  
  void set_search_column(int column);

  ///void on_search_equal(const Glib::RefPtr<TreeModel>& model, int column, const Glib::ustring& key, const TreeIter& iter)
  typedef SigC::Slot4<bool, const Glib::RefPtr<TreeModel>&, int, const Glib::ustring&, const TreeIter&> SlotSearchEqual;
  //SlotSearchEqual get_search_equal_func();
  void set_search_equal_func(const SlotSearchEqual& slot);
  

//TODO: Why do we have this special conversion?:
 

  /**
   * @par Prototype:
   * <tt>void %set_scroll_adjustments(Adjustment* hadjustment, Adjustment* vadjustment)</tt>
   */
  Glib::SignalProxy2<void,Adjustment*,Adjustment*> signal_set_scroll_adjustments();

  
  /**
   * @par Prototype:
   * <tt>void %row_activated(const TreePath& path, TreeViewColumn* column)</tt>
   */
  Glib::SignalProxy2<void,const TreePath&,TreeViewColumn*> signal_row_activated();

  
  /**
   * @par Prototype:
   * <tt>bool %test_expand_row(const TreeIter& iter, const TreePath& path)</tt>
   */
  Glib::SignalProxy2<bool,const TreeIter&,const TreePath&> signal_test_expand_row();

  
  /**
   * @par Prototype:
   * <tt>bool %test_collapse_row(const TreeIter& iter, const TreePath& path)</tt>
   */
  Glib::SignalProxy2<bool,const TreeIter&,const TreePath&> signal_test_collapse_row();

  
  /**
   * @par Prototype:
   * <tt>void %row_expanded(const TreeIter& iter, const TreePath& path)</tt>
   */
  Glib::SignalProxy2<void,const TreeIter&,const TreePath&> signal_row_expanded();

  
  /**
   * @par Prototype:
   * <tt>void %row_collapsed(const TreeIter& iter, const TreePath& path)</tt>
   */
  Glib::SignalProxy2<void,const TreeIter&,const TreePath&> signal_row_collapsed();

  
  /**
   * @par Prototype:
   * <tt>void %cursor_changed()</tt>
   */
  Glib::SignalProxy0<void> signal_cursor_changed();

  
  /**
   * @par Prototype:
   * <tt>void %columns_changed()</tt>
   */
  Glib::SignalProxy0<void> signal_columns_changed();


  /**
   * @par Prototype:
   * <tt>bool %move_cursor(MovementStep step, int count)</tt>
   */
  Glib::SignalProxy2<bool,MovementStep,int> signal_move_cursor();

  
  /**
   * @par Prototype:
   * <tt>void %select_all()</tt>
   */
  Glib::SignalProxy0<void> signal_select_all();

  
  /**
   * @par Prototype:
   * <tt>void %unselect_all()</tt>
   */
  Glib::SignalProxy0<void> signal_unselect_all();

  
  /**
   * @par Prototype:
   * <tt>void %select_cursor_row(bool start_editing)</tt>
   */
  Glib::SignalProxy1<void,bool> signal_select_cursor_row();

  
  /**
   * @par Prototype:
   * <tt>void %toggle_cursor_row()</tt>
   */
  Glib::SignalProxy0<void> signal_toggle_cursor_row();

  
  /**
   * @par Prototype:
   * <tt>void %expand_collapse_cursor_row(bool logical, bool expand, bool open_all)</tt>
   */
  Glib::SignalProxy3<void,bool,bool,bool> signal_expand_collapse_cursor_row();

  
  /**
   * @par Prototype:
   * <tt>void %select_cursor_parent()</tt>
   */
  Glib::SignalProxy0<void> signal_select_cursor_parent();

  
  /**
   * @par Prototype:
   * <tt>void %start_interactive_search()</tt>
   */
  Glib::SignalProxy0<void> signal_start_interactive_search();


  Glib::PropertyProxy< Glib::RefPtr<TreeModel> > property_model();

  Glib::PropertyProxy<Adjustment*> property_hadjustment();

  Glib::PropertyProxy<Adjustment*> property_vadjustment();

  Glib::PropertyProxy<bool> property_headers_visible();

  Glib::PropertyProxy_WriteOnly<bool> property_headers_clickable();

  Glib::PropertyProxy<TreeViewColumn*> property_expander_column();

  Glib::PropertyProxy<bool> property_reorderable();

  Glib::PropertyProxy<bool> property_rules_hint();

  Glib::PropertyProxy<bool> property_enable_search();

  Glib::PropertyProxy<int> property_search_column();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::TreeView */
  Gtk::TreeView* wrap(GtkTreeView* object, bool take_copy = false);
}
#endif /* _GTKMM_TREEVIEW_H */

