// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_TREEVIEWCOLUMN_H
#define _GTKMM_TREEVIEWCOLUMN_H

#include <glibmm.h>

/* $Id: treeviewcolumn.hg,v 1.26 2002/04/16 13:01:53 murrayc Exp $ */


/* treeviewcolumn.h
 *
 * Copyright(C) 2001 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/object.h>
#include <gtkmm/treeiter.h>
#include <gtkmm/widget.h>
#include <gdkmm/window.h>
#include <gtkmm/cellrenderer.h>
#include <gtkmm/treemodel.h>
#include <glibmm/listhandle.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkTreeViewColumn GtkTreeViewColumn;
typedef struct _GtkTreeViewColumnClass GtkTreeViewColumnClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class TreeViewColumn_Class; } // namespace Gtk
namespace Gtk
{


/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum TreeViewColumnSizing
{
  TREE_VIEW_COLUMN_GROW_ONLY,
  TREE_VIEW_COLUMN_AUTOSIZE,
  TREE_VIEW_COLUMN_FIXED
};

} // namespace Gtk

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::TreeViewColumnSizing> : public Glib::Value_Enum<Gtk::TreeViewColumnSizing>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


/** This is a visible column in a Gtk::TreeView widget. It determines the geometry, type
 * @ingroup TreeView
*/

class TreeViewColumn : public Gtk::Object
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TreeViewColumn CppObjectType;
  typedef TreeViewColumn_Class CppClassType;
  typedef GtkTreeViewColumn BaseObjectType;
  typedef GtkTreeViewColumnClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~TreeViewColumn();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class TreeViewColumn_Class;
  static CppClassType treeviewcolumn_class_;

  TreeViewColumn(const TreeViewColumn&);
  TreeViewColumn& operator=(const TreeViewColumn&); // not implemented

protected:
  explicit TreeViewColumn(GtkTreeViewColumn* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkTreeViewColumn* gobj()             { return (GtkTreeViewColumn*)(gobject_); }
  const GtkTreeViewColumn* gobj() const { return (GtkTreeViewColumn*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_clicked();


private:

  
public:
  TreeViewColumn();
  TreeViewColumn(const Glib::ustring& title, CellRenderer& cell);
  

  void pack_start(CellRenderer& cell, bool expand = true);
  
  void pack_end(CellRenderer& cell, bool expand = true);
  
  void clear();
  
  Glib::ListHandle<CellRenderer*> get_cell_renderers();
  
  void add_attribute(CellRenderer& cell_renderer, const Glib::ustring& attribute, int column);

  void add_attribute(const Glib::PropertyProxy_Base& property, const TreeModelColumnBase& column);

 // _WRAP_METHOD(void set_attributes(CellRenderer& cell_renderer, ...), )

  typedef SigC::Slot4<void, TreeViewColumn*, CellRenderer*, const Glib::RefPtr<Gtk::TreeModel>&, const Gtk::TreeIter&> SlotCellData;
  void set_cell_data_func(CellRenderer& cell_renderer, const SlotCellData& slot);

  
  void clear_attributes(CellRenderer& cell_renderer);
  
  void set_spacing(int spacing);
  
  int get_spacing();
  
  void set_visible(bool visible = true);
  
  bool get_visible();
  
  void set_resizable(bool resizable = true);
  
  bool get_resizable() const;
  
  void set_sizing(TreeViewColumnSizing type);
  
  TreeViewColumnSizing get_sizing();
  
  int get_width();
  
  int get_fixed_width();
  
  void set_fixed_width(int fixed_width);
  
  void set_min_width(int min_width);
  
  int get_min_width();
  
  void set_max_width(int max_width);
  
  int get_max_width();
  
  void clicked();

  
  void set_title(const Glib::ustring& title);
  
  Glib::ustring get_title();
  
  void set_clickable(bool clickable = true);
  
  bool get_clickable();
  
  void set_widget(GtkWidget* widget);
  
  Widget* get_widget();
  
  void set_alignment(float xalign);
  
  float get_alignment();
  
  void set_reorderable(bool reorderable);
  
  bool get_reorderable();

  
  void set_sort_column_id(int sort_column_id);
  
  int get_sort_column_id();
  
  void set_sort_indicator(bool setting);
  
  bool get_sort_indicator();
  
  void set_sort_order(SortType order);
  
  SortType get_sort_order();


  void cell_set_cell_data(const Glib::RefPtr<TreeModel>& tree_model, const TreeIter& iter, bool is_expander, bool is_expanded);
  
  void cell_get_size(Gdk::Rectangle& cell_area, int& x_offset, int& y_offset, int& width, int& height);
  
  bool cell_is_visible();

  
  /**
   * @par Prototype:
   * <tt>void %clicked()</tt>
   */
  Glib::SignalProxy0<void> signal_clicked();


  Glib::PropertyProxy<bool> property_visible();

  Glib::PropertyProxy_ReadOnly<int> property_width();

  Glib::PropertyProxy<TreeViewColumnSizing> property_sizing();

  Glib::PropertyProxy<int> property_fixed_width();

  Glib::PropertyProxy<int> property_min_width();

  Glib::PropertyProxy<int> property_max_width();

  Glib::PropertyProxy<Glib::ustring> property_title();

  Glib::PropertyProxy<bool> property_clickable();

  Glib::PropertyProxy<Widget*> property_widget();

  Glib::PropertyProxy<float> property_alignment();

  Glib::PropertyProxy<bool> property_reorderable();

  Glib::PropertyProxy<bool> property_sort_indicator();

  Glib::PropertyProxy<SortType> property_sort_order();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::TreeViewColumn */
  Gtk::TreeViewColumn* wrap(GtkTreeViewColumn* object, bool take_copy = false);
}
#endif /* _GTKMM_TREEVIEWCOLUMN_H */

